## rustc-1.80 1.80.1%2Bdfsg0ubuntu1~bpo0

=== tests/run-make/sanitizer-dylib-link/Makefile ===
# needs-sanitizer-support
# needs-sanitizer-address

include ../tools.mk

LOG := $(TMPDIR)/log.txt

# This test builds a shared object, then an executable that links it as a native
# rust library (contrast to an rlib). The shared library and executable both
# are compiled with address sanitizer, and we assert that a fault in the dylib
# is correctly detected.

all:
	$(RUSTC) -g -Z sanitizer=address --crate-type dylib --target $(TARGET) library.rs
	$(RUSTC) -g -Z sanitizer=address --crate-type bin --target $(TARGET) program.rs
	LD_LIBRARY_PATH=$(TMPDIR) $(TMPDIR)/program 2>&1 | $(CGREP) stack-buffer-overflow

## rustc-1.80 1.80.1+dfsg0ubuntu1~bpo0

=== tests/run-make/allocator-shim-circular-deps/Makefile ===
# This test is designed to intentionally introduce a circular dependency scenario to check that a specific compiler bug doesn't make a resurgence.
# The bug in question arose when at least one crate required a global allocator, and that crate was placed after the one defining it in the linker order. 
# The generated symbols.o should not result in any linker errors.
# See https://github.com/rust-lang/rust/issues/112715

# ignore-cross-compile
include ../tools.mk

all:
	rm -rf $(TMPDIR) && mkdir $(TMPDIR)
	$(RUSTC) my_lib.rs
	$(RUSTC) main.rs --test --extern my_lib=$(TMPDIR)/libmy_lib.rlib

=== tests/run-make/c-static-dylib/Makefile ===
# This test checks that static Rust linking with C does not encounter any errors, with dynamic dependencies given preference over static.
# See https://github.com/rust-lang/rust/issues/10434

# ignore-cross-compile
include ../tools.mk

all: $(call NATIVE_STATICLIB,cfoo)
	$(RUSTC) foo.rs -C prefer-dynamic
	$(RUSTC) bar.rs
	rm $(call NATIVE_STATICLIB,cfoo)
	$(call RUN,bar)
	$(call REMOVE_DYLIBS,foo)
	$(call FAIL,bar)

=== tests/run-make/codegen-options-parsing/Makefile ===
# This test intentionally feeds invalid inputs to codegen and checks if the error message outputs contain specific helpful indications.

# ignore-cross-compile
include ../tools.mk

all:
	#Option taking a number
	$(RUSTC) -C codegen-units dummy.rs 2>&1 | \
		$(CGREP) 'codegen option `codegen-units` requires a number'
	$(RUSTC) -C codegen-units= dummy.rs 2>&1 | \
		$(CGREP) 'incorrect value `` for codegen option `codegen-units` - a number was expected'
	$(RUSTC) -C codegen-units=foo dummy.rs 2>&1 | \
		$(CGREP) 'incorrect value `foo` for codegen option `codegen-units` - a number was expected'
	$(RUSTC) -C codegen-units=1 dummy.rs
	#Option taking a string
	$(RUSTC) -C extra-filename dummy.rs 2>&1 | \
		$(CGREP) 'codegen option `extra-filename` requires a string'
	$(RUSTC) -C extra-filename= dummy.rs 2>&1
	$(RUSTC) -C extra-filename=foo dummy.rs 2>&1
	#Option taking no argument
	$(RUSTC) -C lto= dummy.rs 2>&1 | \
		$(CGREP) 'codegen option `lto` - either a boolean (`yes`, `no`, `on`, `off`, etc), `thin`, `fat`, or omitted'
	$(RUSTC) -C lto=1 dummy.rs 2>&1 | \
		$(CGREP) 'codegen option `lto` - either a boolean (`yes`, `no`, `on`, `off`, etc), `thin`, `fat`, or omitted'
	$(RUSTC) -C lto=foo dummy.rs 2>&1 | \
		$(CGREP) 'codegen option `lto` - either a boolean (`yes`, `no`, `on`, `off`, etc), `thin`, `fat`, or omitted'
	$(RUSTC) -C lto dummy.rs

	# Should not link dead code...
	$(RUSTC) --print link-args dummy.rs 2>&1 | \
		$(CGREP) -e '--gc-sections|-z[^ ]* [^ ]*<ignore>|-dead_strip|/OPT:REF'
	# ... unless you specifically ask to keep it
	$(RUSTC) --print link-args -C link-dead-code dummy.rs 2>&1 | \
		$(CGREP) -ve '--gc-sections|-z[^ ]* [^ ]*<ignore>|-dead_strip|/OPT:REF'

=== tests/run-make/compiler-lookup-paths/Makefile ===
# rustc supports different types of lookup paths, such as dependency, native or crate. This test checks that these lookup paths are functional and result in functional compilation.
# See https://github.com/rust-lang/rust/pull/19941

include ../tools.mk

# ignore-wasm32 (need a C compiler)
# ignore-wasm64 (need a C compiler)

all: $(TMPDIR)/libnative.a
	mkdir -p $(TMPDIR)/crate
	mkdir -p $(TMPDIR)/native
	mv $(TMPDIR)/libnative.a $(TMPDIR)/native
	$(RUSTC) a.rs
	mv $(TMPDIR)/liba.rlib $(TMPDIR)/crate
	$(RUSTC) b.rs -L native=$(TMPDIR)/crate && exit 1 || exit 0
	$(RUSTC) b.rs -L dependency=$(TMPDIR)/crate && exit 1 || exit 0
	$(RUSTC) b.rs -L crate=$(TMPDIR)/crate
	$(RUSTC) b.rs -L all=$(TMPDIR)/crate
	$(RUSTC) c.rs -L native=$(TMPDIR)/crate && exit 1 || exit 0
	$(RUSTC) c.rs -L crate=$(TMPDIR)/crate && exit 1 || exit 0
	$(RUSTC) c.rs -L dependency=$(TMPDIR)/crate
	$(RUSTC) c.rs -L all=$(TMPDIR)/crate
	$(RUSTC) d.rs -L dependency=$(TMPDIR)/native && exit 1 || exit 0
	$(RUSTC) d.rs -L crate=$(TMPDIR)/native && exit 1 || exit 0
	$(RUSTC) d.rs -L native=$(TMPDIR)/native
	$(RUSTC) d.rs -L all=$(TMPDIR)/native
	# Deduplication tests:
	#   Same hash, no errors.
	mkdir -p $(TMPDIR)/e1
	mkdir -p $(TMPDIR)/e2
	$(RUSTC) e.rs -o $(TMPDIR)/e1/libe.rlib
	$(RUSTC) e.rs -o $(TMPDIR)/e2/libe.rlib
	$(RUSTC) f.rs -L $(TMPDIR)/e1 -L $(TMPDIR)/e2
	$(RUSTC) f.rs -L crate=$(TMPDIR)/e1 -L $(TMPDIR)/e2
	$(RUSTC) f.rs -L crate=$(TMPDIR)/e1 -L crate=$(TMPDIR)/e2
	#   Different hash, errors.
	$(RUSTC) e2.rs -o $(TMPDIR)/e2/libe.rlib
	$(RUSTC) f.rs -L $(TMPDIR)/e1 -L $(TMPDIR)/e2 && exit 1 || exit 0
	$(RUSTC) f.rs -L crate=$(TMPDIR)/e1 -L $(TMPDIR)/e2 && exit 1 || exit 0
	$(RUSTC) f.rs -L crate=$(TMPDIR)/e1 -L crate=$(TMPDIR)/e2 && exit 1 || exit 0
	#   Native/dependency paths don't cause errors.
	$(RUSTC) f.rs -L native=$(TMPDIR)/e1 -L $(TMPDIR)/e2
	$(RUSTC) f.rs -L dependency=$(TMPDIR)/e1 -L $(TMPDIR)/e2
	$(RUSTC) f.rs -L dependency=$(TMPDIR)/e1 -L crate=$(TMPDIR)/e2

=== tests/run-make/emit-stack-sizes/Makefile ===
include ../tools.mk

# ignore-windows
# ignore-apple
#
# This feature only works when the output object format is ELF so we ignore
# Apple and Windows

# check that the .stack_sizes section is generated
all:
	$(RUSTC) -C opt-level=3 -Z emit-stack-sizes --emit=obj foo.rs
	size -A $(TMPDIR)/foo.o | $(CGREP) .stack_sizes

=== tests/run-make/issue-85019-moved-src-dir/Makefile ===
include ../tools.mk

INCR=$(TMPDIR)/incr
FIRST_SRC=$(TMPDIR)/first_src
SECOND_SRC=$(TMPDIR)/second_src

# ignore-none no-std is not supported
# ignore-nvptx64-nvidia-cuda FIXME: can't find crate for 'std'

# Tests that we don't get an ICE when the working directory
# (but not the build directory!) changes between compilation
# sessions

all:
	mkdir $(INCR)
	# Build from 'FIRST_SRC'
	mkdir $(FIRST_SRC)
	cp my_lib.rs $(FIRST_SRC)/my_lib.rs
	cp main.rs $(FIRST_SRC)/main.rs
	cd $(FIRST_SRC) && \
		$(RUSTC) -C incremental=$(INCR) --crate-type lib my_lib.rs --target $(TARGET) && \
		$(RUSTC) -C incremental=$(INCR) --extern my_lib=$(TMPDIR)/libmy_lib.rlib main.rs --target $(TARGET)
	# Build from 'SECOND_SRC', keeping the output directory and incremental directory
	# the same
	mv $(FIRST_SRC) $(SECOND_SRC)
	cd $(SECOND_SRC) && \
		$(RUSTC) -C incremental=$(INCR) --crate-type lib my_lib.rs --target $(TARGET) && \
		$(RUSTC) -C incremental=$(INCR) --extern my_lib=$(TMPDIR)/libmy_lib.rlib main.rs --target $(TARGET)

=== tests/run-make/libtest-padding/Makefile ===
# ignore-cross-compile because we run the compiled code
# needs-unwind because #[bench] and -Cpanic=abort requires -Zpanic-abort-tests
include ../tools.mk

NORMALIZE=sed 's%[0-9,\.]\{1,\} ns/iter (+/- [0-9,\.]\{1,\})%?? ns/iter (+/- ??)%' | sed 's%finished in [0-9\.]\{1,\}%finished in ??%'

all:
	$(RUSTC) --test tests.rs

	$(call RUN,tests) --test-threads=1 | $(NORMALIZE) > "$(TMPDIR)"/test.stdout
	$(RUSTC_TEST_OP) "$(TMPDIR)"/test.stdout test.stdout

	$(call RUN,tests) --test-threads=1 --bench | $(NORMALIZE) > "$(TMPDIR)"/bench.stdout
	$(RUSTC_TEST_OP) "$(TMPDIR)"/bench.stdout bench.stdout

=== tests/run-make/lto-dylib-dep/Makefile ===
# ignore-cross-compile
include ../tools.mk

# Test that we don't run into an assertion when using a Rust dylib dependency
# while compiling with full LTO.
# See https://github.com/rust-lang/rust/issues/59137

all:
	$(RUSTC) a_dylib.rs --crate-type=dylib -C prefer-dynamic
	$(RUSTC) main.rs -C lto
	$(call RUN,main)

=== tests/run-make/macos-fat-archive/Makefile ===
# only-apple

include ../tools.mk

"$(TMPDIR)"/libnative-library.a: native-library.c
	$(CC) -arch arm64 -arch x86_64 native-library.c -c -o "$(TMPDIR)"/native-library.o
	$(AR) crs "$(TMPDIR)"/libnative-library.a "$(TMPDIR)"/native-library.o

all: "$(TMPDIR)"/libnative-library.a
	$(RUSTC) lib.rs --crate-type=lib -L "native=$(TMPDIR)" -l static=native-library

=== tests/run-make/msvc-opt-minsize/Makefile ===
# ignore-cross-compile
include ../tools.mk

all:
	$(RUSTC) foo.rs -Copt-level=z 2>&1
	$(call RUN,foo)

=== tests/run-make/native-link-modifier-verbatim-linker/Makefile ===
# ignore-cross-compile
# ignore-apple

include ../tools.mk

all:
	# Verbatim allows specify precise name.
	$(RUSTC) local_native_dep.rs --crate-type=staticlib -o $(TMPDIR)/local_some_strange_name.ext
	$(RUSTC) main.rs -l static:+verbatim=local_some_strange_name.ext

	# With verbatim any other name cannot be used (local).
	$(RUSTC) local_native_dep.rs --crate-type=staticlib -o $(TMPDIR)/liblocal_native_dep.a
	$(RUSTC) local_native_dep.rs --crate-type=staticlib -o $(TMPDIR)/local_native_dep.a
	$(RUSTC) local_native_dep.rs --crate-type=staticlib -o $(TMPDIR)/local_native_dep.lib
	$(RUSTC) main.rs -l static:+verbatim=local_native_dep 2>&1 | $(CGREP) "local_native_dep"

=== tests/run-make/native-link-modifier-whole-archive/Makefile ===
# ignore-cross-compile -- compiling C++ code does not work well when cross-compiling

# This test case makes sure that native libraries are linked with appropriate semantics
# when the `[+-]bundle,[+-]whole-archive` modifiers are applied to them.
#
# The test works by checking that the resulting executables produce the expected output,
# part of which is emitted by otherwise unreferenced C code. If +whole-archive didn't work
# that code would never make it into the final executable and we'd thus be missing some
# of the output.

include ../tools.mk

all: $(TMPDIR)/$(call BIN,directly_linked) \
     $(TMPDIR)/$(call BIN,directly_linked_test_plus_whole_archive) \
     $(TMPDIR)/$(call BIN,directly_linked_test_minus_whole_archive) \
     $(TMPDIR)/$(call BIN,indirectly_linked) \
     $(TMPDIR)/$(call BIN,indirectly_linked_via_attr)
	$(call RUN,directly_linked) | $(CGREP) 'static-initializer.directly_linked.'
	$(call RUN,directly_linked_test_plus_whole_archive) --nocapture | $(CGREP) 'static-initializer.'
	$(call RUN,directly_linked_test_minus_whole_archive) --nocapture | $(CGREP) -v 'static-initializer.'
	$(call RUN,indirectly_linked) | $(CGREP) 'static-initializer.indirectly_linked.'
	$(call RUN,indirectly_linked_via_attr) | $(CGREP) 'static-initializer.native_lib_in_src.'

# Native lib linked directly into executable
$(TMPDIR)/$(call BIN,directly_linked): $(call NATIVE_STATICLIB,c_static_lib_with_constructor)
	$(RUSTC) directly_linked.rs -l static:+whole-archive=c_static_lib_with_constructor

# Native lib linked into test executable, +whole-archive
$(TMPDIR)/$(call BIN,directly_linked_test_plus_whole_archive): $(call NATIVE_STATICLIB,c_static_lib_with_constructor)
	$(RUSTC) directly_linked_test_plus_whole_archive.rs --test -l static:+whole-archive=c_static_lib_with_constructor
# Native lib linked into test executable, -whole-archive
$(TMPDIR)/$(call BIN,directly_linked_test_minus_whole_archive): $(call NATIVE_STATICLIB,c_static_lib_with_constructor)
	$(RUSTC) directly_linked_test_minus_whole_archive.rs --test -l static:-whole-archive=c_static_lib_with_constructor

# Native lib linked into RLIB via `-l static:-bundle,+whole-archive`, RLIB linked into executable
$(TMPDIR)/$(call BIN,indirectly_linked): $(TMPDIR)/librlib_with_cmdline_native_lib.rlib
	$(RUSTC) indirectly_linked.rs

# Native lib linked into RLIB via #[link] attribute, RLIB linked into executable
$(TMPDIR)/$(call BIN,indirectly_linked_via_attr): $(TMPDIR)/libnative_lib_in_src.rlib
	$(RUSTC) indirectly_linked_via_attr.rs

# Native lib linked into rlib with via commandline
$(TMPDIR)/librlib_with_cmdline_native_lib.rlib: $(call NATIVE_STATICLIB,c_static_lib_with_constructor)
	$(RUSTC) rlib_with_cmdline_native_lib.rs --crate-type=rlib -l static:-bundle,+whole-archive=c_static_lib_with_constructor

# Native lib linked into rlib via `#[link()]` attribute on extern block.
$(TMPDIR)/libnative_lib_in_src.rlib: $(call NATIVE_STATICLIB,c_static_lib_with_constructor)
	$(RUSTC) native_lib_in_src.rs --crate-type=rlib

$(TMPDIR)/libc_static_lib_with_constructor.o: c_static_lib_with_constructor.cpp
	$(call COMPILE_OBJ_CXX,$@,$<)

=== debian/changelog ===
rustc-1.80 (1.80.1+dfsg0ubuntu1~bpo0-0ubuntu0.22.04) jammy; urgency=medium

  * Backport to Jammy (LP: #2076206)
    - d/p/ubuntu-backport-disable-newer-tests.patch: add a patch to disable
      newer tests that can't pass on older Ubuntu series
    - d/p/ubuntu-jammy-skip-gdb-tests-on-armhf.patch: add a patch to
      disable gdb tests on armhf
    - Re-enable libgit2 vendoring:
      - d/control: remove libgit2-dev and libhttp-parser-dev from B-D
    - Re-enable LLVM vendoring (LLVM 18.1.7)
    - d/control: Comment out the Vendored-Sources-Rust support as it's
      not available in older releases
    - d/control: revert pkgconf to pkg-config

 -- Zixing Liu <zixing.liu@canonical.com>  Tue, 20 Aug 2024 00:45:12 -0600

rustc-1.80 (1.80.1+dfsg0ubuntu1-0ubuntu1) oracular; urgency=medium

  * New upstream release 1.80.1 (LP: #2076206)
    - d/patches: refresh patches
    - d/copyright: update the list of unused vendored dependencies
    - d/copyright: delete src/tools/rustc-perf we don't need this upstream
      benchmarking facility (not used anywhere)
    - d/control: re-generate files for rustc-1.80
    - d/p/series: remove opener-cherry-pick-fix-to-avoid-vendored-dbus.patch
  * d/p/upstream/u-add-missing-f16-intrinsics.patch,
    d/p/upstream/u-add-f16-f128-handling-in-a-couple-places.patch,
    d/p/upstream/u-limit-f16-doctests-to-x86.patch,
    d/p/upstream/u-disable-f16-f128-on-unsupported-platforms.patch:
    backported patches from upstream to fix compiler crash from LLVM
    mishandling f16 lowering on some platforms
  * d/p/ubuntu/ubuntu-fix-f16-fallback-intrinsics.patch: add a patch to fix
    LLVM misoptimizations

 -- Zixing Liu <zixing.liu@canonical.com>  Thu, 08 Aug 2024 08:56:51 -0600

rustc-1.79 (1.79.0+dfsg1ubuntu1-0ubuntu1) oracular; urgency=medium

  [ Zixing Liu ]
  * New upstream release 1.79.0 (LP: #2076205)
  * d/p/ubuntu/ubuntu-add-s390x-allowed-features.patch: backport the patch
  * d/p/ubuntu/ubuntu-disable-ppc64el-asm-tests.patch: refresh the patch
  * d/p/prune/d-0021-vendor-remove-windows-dependencies.patch: refresh the patch
  * d/copyright: update the list of unused Rust dependencies
  * d/control.in: update vendored dependency list
  * d/p/build/d-bootstrap-disable-git.patch: fix the patch so that version
    information is still included correctly when building under
    Debian or Ubuntu
  * d/p/prune/d-0020-remove-windows-dependencies.patch: refresh the patch
  * d/p/prune/d-0021-vendor-remove-windows-dependencies.patch: refresh
    the patch
  * d/source/lintian-overrides.in: add another ignore pattern for rustdoc tests
  * d/copyright: remove unused globs

  [ Fabian Grünbichler ]
  * d/copyright: adapt to vendor/ version suffix
  * early-stage update of patches for 1.79.0
  * d/copyright: also exclude vendored libdbus
  * update Files-Excluded for 1.79.0
  * upstream unsuspicious: adapt to new vendor suffix
  * update upstream unsuspicious for 1.79
  * d/update-version.sh: adapt to wasi-libc/sdk changes
  * d/rules: fix for suffixed vendored crates
  * config: adapt to new change tracking mechanism
  * cargo wrapper: switch to config.toml
  * cargo wrapper: ensure debug symbols are not stripped
  * add missing rustfmt dependency (Closes: #1074290)
  * build: remove more cache files (Closes: #1074373)

  [ Samuel Thibault ]
  * Avoid hurd-stuck test

 -- Zixing Liu <zixing.liu@canonical.com>  Mon, 29 Jul 2024 03:04:07 -0600

rustc-1.78 (1.78.0+dfsg1ubuntu1-0ubuntu1) oracular; urgency=medium

  * New upstream release 1.78.0 (LP: #2075108)
    - d/control{,.in}: rename to rust-1.78 and re-generate
    - d/p/ubuntu/ubuntu-use-system-profiler-rt.patch: remove the patch as 
      we will use the upstream mechanism to specify the LLVM clang-rt
      instead of patching in a hardcoded one
    - d/p/ubuntu/ubuntu-add-s390x-allowed-features.patch: refresh the patch
    - d/copyright: remove unused vendored dependencies
    - d/copyright: update copyright data for vendored dependencies
    - d/p/ubuntu/ubuntu-vendor-no-workspace.patch: refresh patch
    - d/p/ubuntu/ubuntu-use-system-compiler-during-tests.patch: refresh the patch
    - d/s/lintian-overrides: re-generate for Rust 1.78
    - d/*: upgrade to LLVM 18.1
    - d/rules: adapt to changed docs install path
  * d/rules: add forced version check logic so that it will be difficult to
    screw up the version numbers when upgrading the package
  * d/rules: workaround path lookup issues with LLVM profiler runtime
  * d/rules: use upstream mechanism to specify LLVM clang-rt files
  * d/patches: synchronize patches from Debian
  * d/watch: get release information from GitHub but still download tarballs
    from Rust Forge
  * d/libstd-rust-1.76.lintian-overrides: remove auto-generated files
  * d/{rule,config.toml.in,README.source}: rename RUST_DESTDIR to RUST_BOOTSTRAP_DIR

 -- Zixing Liu <zixing.liu@canonical.com>  Thu, 25 Jul 2024 08:46:38 -0600

rustc-1.77 (1.77.2+dfsg1ubuntu1-0ubuntu1) oracular; urgency=medium

  [ Zixing Liu ]

  * New upstream release 1.77.2 (LP: #2070410)
    - d/patches: Refresh patches
    - d/copyright: update the list of unused crates
    - d/copyright: update copyright data
    - d/libstd-rust-*: bump version to 1.77
    - d/patches: remove obsoleted patches   
    - d/s/lintian-overrides*: update lintian overrides
    - d/control: update vendored crate list
  * d/p/ubuntu-add-s390x-allowed-features.patch: fix s390x build with backchain
  * d/tests: fix self-build tests when rust-defaults package does not point to
    the current versioned package
  * d/control: Build-Depends solely on versioned packages

  [ Fabian Grünbichler ]

  * config: don't attempt to optimize compiler-rt
  * update upstream unsuspicious files

 -- Zixing Liu <zixing.liu@canonical.com>  Mon, 08 Jul 2024 23:49:29 -0600

rustc-1.76 (1.76.0+dfsg0ubuntu1-0ubuntu1) oracular; urgency=medium

  * New upstream release 1.76.0 (LP: #2052985)
    - d/patches: Refresh patches


=== debian/control ===
Source: rustc-1.80
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Ximin Luo <infinity0@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>,
 Fabian Grünbichler <debian@fabian.gruenbichler.email>
Rules-Requires-Root: no
# :native annotations are to support cross-compiling, see README.Debian
Build-Depends:
 debhelper (>= 9),
 debhelper-compat (= 13),
# dh-cargo (>= 28ubuntu1~),
 dpkg-dev (>= 1.17.14),
 python3:native,
 cargo-1.79 | cargo-1.80 <!pkg.rustc.dlstage0>,
 rustc-1.79 | rustc-1.80 <!pkg.rustc.dlstage0>,
 cmake (>= 3.20) | cmake3 (>= 3.20),
# needed by some vendor crates
 pkg-config,
# this is sometimes needed by rustc_llvm
 zlib1g-dev:native,
 zlib1g-dev,
# used by rust-installer
 liblzma-dev:native,
# used by cargo
 bash-completion,
 libcurl4-gnutls-dev | libcurl4-openssl-dev,
 libssh2-1-dev,
 libsqlite3-dev,
# Required for llvm build
 autotools-dev,
 m4,
 ninja-build,
# test dependencies:
 binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
 git <!nocheck>,
 procps <!nocheck>,
# Resources loaded from the docs, checked by linkchecker
 libjs-jquery <!nocheck>,
 libjs-highlight.js <!nocheck>,
 libjs-mathjax <!nocheck>,
 fonts-open-sans <!nocheck>,
 fonts-font-awesome <!nocheck>,
# below are optional tools even for 'make check'
 gdb (>= 7.12) <!nocheck>,
 libc6-dbg [armhf],
# Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
 curl <pkg.rustc.dlstage0>,
 ca-certificates <pkg.rustc.dlstage0>,
Build-Depends-Indep:
 libssl-dev,
Build-Conflicts: gdb-minimal (<< 8.1-0ubuntu6) <!nocheck>
Standards-Version: 4.6.2
Homepage: http://www.rust-lang.org/
Vcs-Git: https://salsa.debian.org/rust-team/rust.git
Vcs-Browser: https://salsa.debian.org/rust-team/rust

## rustc-1.80 1.80.1+dfsg0ubuntu1

=== tests/run-make/archive-duplicate-names/Makefile ===
# When two object archives with the same filename are present, an iterator is supposed to inspect each object, recognize the duplication and extract each one to a different directory.
# This test checks that this duplicate handling behaviour has not been broken.
# See https://github.com/rust-lang/rust/pull/24439

# ignore-cross-compile
include ../tools.mk

all:
	mkdir $(TMPDIR)/a
	mkdir $(TMPDIR)/b
	$(call COMPILE_OBJ,$(TMPDIR)/a/foo.o,foo.c)
	$(call COMPILE_OBJ,$(TMPDIR)/b/foo.o,bar.c)
	$(AR) crus $(TMPDIR)/libfoo.a $(TMPDIR)/a/foo.o $(TMPDIR)/b/foo.o
	$(RUSTC) foo.rs
	$(RUSTC) bar.rs
	$(call RUN,bar)

=== tests/run-make/c-static-rlib/Makefile ===
# This test checks that static Rust linking with C does not encounter any errors, with static dependencies given preference over dynamic. (This is the default behaviour.)
# See https://github.com/rust-lang/rust/issues/10434

# ignore-cross-compile
include ../tools.mk

all: $(call NATIVE_STATICLIB,cfoo)
	$(RUSTC) foo.rs
	$(RUSTC) bar.rs
	$(call REMOVE_RLIBS,foo)
	rm $(call NATIVE_STATICLIB,cfoo)
	$(call RUN,bar)

=== tests/run-make/c-unwind-abi-catch-panic/Makefile ===
# Exercise unwinding a panic. This catches a panic across an FFI boundary and downcasts it into an integer. The Rust code that panics is in the same directory.
# See https://github.com/rust-lang/rust/commit/baf227ea0c1e07fc54395a51e4b3881d701180cb

# ignore-cross-compile
# needs-unwind
include ../tools.mk

all: $(call NATIVE_STATICLIB,add)
	$(RUSTC) main.rs
	$(call RUN,main) || exit 1

=== tests/run-make/cdylib-fewer-symbols/Makefile ===
# ignore-cross-compile

# Test that allocator-related symbols don't show up as exported from a cdylib as
# they're internal to Rust and not part of the public ABI.
# See https://github.com/rust-lang/rust/commit/fbf98697021173a30b84d9145df0966a23a2f9d2

include ../tools.mk

# ignore-windows
# FIXME: The __rdl_ and __rust_ symbol still remains, no matter using MSVC or GNU
# See https://github.com/rust-lang/rust/pull/46207#issuecomment-347561753

all:
	$(RUSTC) foo.rs
	nm -g "$(call DYLIB,foo)" | $(CGREP) -v __rdl_ __rde_ __rg_ __rust_

=== tests/run-make/comment-section/Makefile ===
# Both GCC and Clang write by default a `.comment` section with compiler information. Rustc received a similar .comment section, so this tests checks that this section properly appears.
# See https://github.com/rust-lang/rust/commit/74b8d324eb77a8f337b35dc68ac91b0c2c06debc

include ../tools.mk

# only-linux

all:
	echo 'fn main(){}' | $(RUSTC) - --emit=link,obj -Csave-temps --target=$(TARGET)

	# Check linked output has a `.comment` section with the expected content.
	readelf -p '.comment' $(TMPDIR)/rust_out | $(CGREP) -F 'rustc version 1.'

	# Check all object files (including temporary outputs) have a `.comment`
	# section with the expected content.
	set -e; for f in $(TMPDIR)/*.o; do \
		readelf -p '.comment' $$f | $(CGREP) -F 'rustc version 1.'; \
	done

=== tests/run-make/dylib-chain/Makefile ===
# ignore-cross-compile
include ../tools.mk

all:
	$(RUSTC) m1.rs -C prefer-dynamic
	$(RUSTC) m2.rs -C prefer-dynamic
	$(RUSTC) m3.rs -C prefer-dynamic
	$(RUSTC) m4.rs
	$(call RUN,m4)
	$(call REMOVE_DYLIBS,m1)
	$(call REMOVE_DYLIBS,m2)
	$(call REMOVE_DYLIBS,m3)
	$(call FAIL,m4)

=== tests/run-make/issue-22131/Makefile ===
# ignore-cross-compile
include ../tools.mk

all: foo.rs
	$(RUSTC) --cfg 'feature="bar"' --crate-type lib foo.rs
	$(RUSTDOC) --test --cfg 'feature="bar"' \
		-L $(TMPDIR) foo.rs |\
		$(CGREP) 'foo.rs - foo (line 1) ... ok'

=== tests/run-make/libtest-junit/Makefile ===
# ignore-cross-compile
# needs-unwind contains should_panic test
include ../tools.mk

# Test expected libtest's junit output

OUTPUT_FILE_DEFAULT := $(TMPDIR)/libtest-junit-output-default.xml
OUTPUT_FILE_STDOUT_SUCCESS := $(TMPDIR)/libtest-junit-output-stdout-success.xml

all: f.rs validate_junit.py output-default.xml output-stdout-success.xml
	$(RUSTC) --test f.rs
	RUST_BACKTRACE=0 $(call RUN,f) -Z unstable-options --test-threads=1 --format=junit > $(OUTPUT_FILE_DEFAULT) || true
	RUST_BACKTRACE=0 $(call RUN,f) -Z unstable-options --test-threads=1 --format=junit --show-output > $(OUTPUT_FILE_STDOUT_SUCCESS) || true

	cat $(OUTPUT_FILE_DEFAULT) | "$(PYTHON)" validate_junit.py
	cat $(OUTPUT_FILE_STDOUT_SUCCESS) | "$(PYTHON)" validate_junit.py

	# Normalize the actual output and compare to expected output file
	cat $(OUTPUT_FILE_DEFAULT) | sed 's/time="[0-9.]*"/time="$$TIME"/g' | diff output-default.xml -
	cat $(OUTPUT_FILE_STDOUT_SUCCESS) | sed 's/time="[0-9.]*"/time="$$TIME"/g' | diff output-stdout-success.xml -

=== tests/run-make/multiple-emits/Makefile ===
include ../tools.mk

all:
	$(RUSTC) foo.rs --emit=asm,llvm-ir -o $(TMPDIR)/out 2>&1
	rm $(TMPDIR)/out.ll $(TMPDIR)/out.s
	$(RUSTC) foo.rs --emit=asm,llvm-ir -o $(TMPDIR)/out2.ext 2>&1
	rm $(TMPDIR)/out2.ll $(TMPDIR)/out2.s

=== tests/run-make/pass-non-c-like-enum-to-c/Makefile ===
# ignore-cross-compile
include ../tools.mk

all: $(call NATIVE_STATICLIB,test)
	$(RUSTC) nonclike.rs -L$(TMPDIR) -ltest
	$(call RUN,nonclike)

=== tests/run-make/prefer-dylib/Makefile ===
# ignore-cross-compile
include ../tools.mk

all:
	$(RUSTC) bar.rs --crate-type=dylib --crate-type=rlib -C prefer-dynamic
	$(RUSTC) foo.rs -C prefer-dynamic
	$(call RUN,foo)
	rm $(TMPDIR)/*bar*
	$(call FAIL,foo)

=== tests/run-make/prefer-rlib/Makefile ===
# ignore-cross-compile
include ../tools.mk

all:
	$(RUSTC) bar.rs --crate-type=dylib --crate-type=rlib
	ls $(TMPDIR)/$(call RLIB_GLOB,bar)
	$(RUSTC) foo.rs
	rm $(TMPDIR)/*bar*
	$(call RUN,foo)

=== debian/changelog ===
rustc-1.80 (1.80.1+dfsg0ubuntu1-0ubuntu2) plucky; urgency=medium

  * d/rust-X.Y-src.links.in: add one more symlink that creates the
    lib/rustlib/src/rust path to help with the Linux kernel build system
    (LP: #2090791)
  * d/p/ubuntu/ubuntu-upgrade-libgit2-1.8.patch: add a patch to upgrade
    libgit2 to 1.8
  * d/control: adjust libgit2 version requirements to 1.8.x (LP: #2089696)

 -- Zixing Liu <zixing.liu@canonical.com>  Wed, 18 Dec 2024 12:08:22 -0700

=== debian/control ===
--- 
+++ 
@@ -12,14 +12,18 @@
 Build-Depends:
  debhelper (>= 9),
  debhelper-compat (= 13),
-# dh-cargo (>= 28ubuntu1~),
+ dh-cargo (>= 28ubuntu1~),
  dpkg-dev (>= 1.17.14),
  python3:native,
  cargo-1.79 | cargo-1.80 <!pkg.rustc.dlstage0>,
  rustc-1.79 | rustc-1.80 <!pkg.rustc.dlstage0>,
- cmake (>= 3.20) | cmake3 (>= 3.20),
+ llvm-18-dev:native,
+ llvm-18-tools:native,
+ libclang-rt-18-dev (>= 1:18.1.2),
+ libclang-common-18-dev (>= 1:18.1.2),
+ cmake (>= 3.0) | cmake3,
 # needed by some vendor crates
- pkg-config,
+ pkgconf,
 # this is sometimes needed by rustc_llvm
  zlib1g-dev:native,
  zlib1g-dev,
@@ -29,11 +33,10 @@
  bash-completion,
  libcurl4-gnutls-dev | libcurl4-openssl-dev,
  libssh2-1-dev,
+ libgit2-dev (>= 1.8.0),
+ libgit2-dev (<< 1.9~~),
+ libhttp-parser-dev,
  libsqlite3-dev,
-# Required for llvm build
- autotools-dev,
- m4,
- ninja-build,
 # test dependencies:
  binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
  git <!nocheck>,
@@ -51,6 +54,7 @@
  curl <pkg.rustc.dlstage0>,
  ca-certificates <pkg.rustc.dlstage0>,
 Build-Depends-Indep:
+ clang-18:native,
  libssl-dev,
 Build-Conflicts: gdb-minimal (<< 8.1-0ubuntu6) <!nocheck>
 Standards-Version: 4.6.2
